<template>
  <single-pane :capt="dictionaryRu.title">
    <ob-table
      :columns="columnsObTable"
      :functionalPanel="true"
      :remote-opt="getObTableData"
      :remote-trigger="hasChangedData"
      is-fixed-header
      ref="obTable"
      @select="onSelection"
    />
    <ob-modal
      ref="viewItem"
      :title="dictionaryRu.modal.title"
      custom-class="modal-medium"
      :is-show-pagination="true"
      :is-read-only="true"
    >
      <dangerous-goods-class
        :selected-data="selectedData"
        :image-data="imageData"
        :api="api"
        @changed-image="onChangedImage"
        @refresh="onRefresh"
        @delete="onDelete(selectedData.uuid)"
      />
    </ob-modal>
  </single-pane>
</template>

<script>
import api                   from '@/api';
import paging                from '@/mixins/dictionaries/paging'
import itemMixin             from '@/mixins/dictionaries/edit-item'
import SinglePane            from 'common-components/src/obComponents/obSinglePanels'
import ObModal               from 'common-components/src/obComponents/obModal'
import ObTable               from 'common-components/src/obComponents/obTable'
import DangerousGoodsClass   from './modal/DangerousGoodsClass'
import { dictionaryDefault } from '@/translations/ru/default'
import { dictionary }        from '@/translations/ru/dictionaries__cargo__dangerous_goods_classes'

export default {
  name: 'DangerousGoodsClasses',
  components: {
    ObModal,
    DangerousGoodsClass,
    ObTable,
    SinglePane
  },
  mixins: [
    paging,
    itemMixin
  ],
  computed: {
    columnsObTable () {
      return [
        {
          title: this.dictionaryRu.columns.code,
          key: 'code',
        },
        {
          title: this.dictionaryRu.columns.adr_class,
          key: 'adr_class',
        },
        {
          title: this.dictionaryRu.columns.hazard_code,
          key: 'hazard_code',
        },
        {
          title: this.dictionaryRu.columns.name,
          key: 'name',
        },
        {
          title: this.dictionaryRu.columns.status,
          width: 110,
          key: 'is_active',
          html: (data) => {
            return data.is_active
              ? this.dictionaryRu.status.active
              : this.dictionaryRu.status.inactive
          }
        },
      ]
    }
  },
  data() {
    return {
      imageData: '',
      selectedData: {},
      dataGridRefName: 'DangerousGoodsClasses',
      api: {
        source: 'oboz2-dictionary-dangerous-goods-classes-viewer/v1/',
      },
      hasChangedData: 1,
      dictionaryRu: Object.assign(dictionary, dictionaryDefault)
    }
  },
  methods: {
    async onSelection(data) {
      try {
        const _data = await this.eiGet(data);
        if (!_data || _data.error) {
          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка загрузки данных о классе опасных грузов'
          })
        } else {
          this.imageData = '';
          this.selectedData = _data.data;
          this.$refs.viewItem.open();
          if (this.selectedData.image_uuid) {
            const _imageData = await api.cargo.getDangerousGoodsClassImage(this.selectedData.image_uuid);
            this.imageData = _imageData.data.content;
          }
        }
      } catch (e) {
        console.error(e);
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки данных'
        })
      }
    },
    onChangedImage (image) {
      this.imageData = image
    },
    async onDelete (uuid) {
      if (!uuid) return

      try {
        await api.cargo.deleteDangerousGoodsClass(uuid)

        this.$refs.viewItem.close()
        this.hasChangedData++
      }
      catch (e) {
        console.error(e);
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка при удалении данных'
        })
      }
    }
  }
}
</script>